﻿package com{
	import flash.display.MovieClip;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.utils.getDefinitionByName;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	
	public class GeoBoard extends MovieClip{
		private var XMLData:XML=new XML();
		private var Panel:MovieClip=new MovieClip();
		private var DotsArray:Array=new Array();
		private var ColorBtnsArray:Array=new Array();
		private var OS:opensh=new opensh();
		private var cs:closedsh=new closedsh();
		private var SelectedDot1:MovieClip;
		private var MouseMoveEnabled:Boolean=false;
		private var DrawingLine:MovieClip;
		private var cur_color:uint=0x41AD49;
		private var ClosedShape:MovieClip;
		private var drawCoords:Vector.<Number> = new Vector.<Number>();
		private var drawCommands:Vector.<int> = new Vector.<int>();
		private var LinesArray:Array=new Array();
		private var closedShapeNum:Number = 0;
		
		public function GeoBoard() {
			LoadXMLData();
		}
		private function LoadXMLData():void
		{
			var xmlLoaderObj:URLLoader=new URLLoader();
			xmlLoaderObj.load(new URLRequest("xml/NTO1_11.xml"));
			xmlLoaderObj.addEventListener(Event.COMPLETE,onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLData=XML((e.currentTarget).data);
			
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));		
			
			CreateActivity();
		}
		private function CreateActivity():void
		{
						
			AddPanel();
			addChild(Panel);
			AddDots();
			AddClosedShape();   
			AddButtons();
		}
		private function AddClosedShape():void
		{
			ClosedShape=new MovieClip()
			addChild(ClosedShape);
			
			/*g2.clear();
			
			//g2.lineStyle(1,0x000000)
			g2.beginFill(cur_color);
			g2.drawEllipse(0,0,20,33);
			g2.endFill();*/
		}
		private function AddPanel():void
		{
			var g:Graphics=Panel.graphics;
			g.lineStyle(XMLData.Panel.@lineThick,XMLData.Panel.@lineColor);
			g.beginFill(XMLData.Panel.@fillColor,1);
			g.drawRect(0,0,XMLData.Panel.@width,XMLData.Panel.@height);
			g.endFill();
			Panel.x=XMLData.Panel.@xpos;
			Panel.y=XMLData.Panel.@ypos;
		}
		private function AddShape():void{
			closedShapeNum++;
			var myCloseShape:MovieClip = new MovieClip();
			myCloseShape.name = "myCloseShape"+closedShapeNum;
			myCloseShape.Num = closedShapeNum;
			myCloseShape.ovalReleased = false;
			myCloseShape.rectClicked = false;
			myCloseShape.coOrdArr = [];
			myCloseShape.dotNum = 2;
			ClosedShape.addChild(myCloseShape);
			myCloseShape.colr = cur_color;
			//myCloseShape.x=SelectedDot1.x-10;
			//myCloseShape.y=SelectedDot1.y;
			var line:Shape=new Shape();
			line.name="line";
			myCloseShape.addChild(line);
			line.x = SelectedDot1.x-10;
			line.y = SelectedDot1.y;
			var fil:Shape=new Shape()
			fil.name="fill";
			myCloseShape.addChild(fil);
			fil.x = SelectedDot1.x-10;
			fil.y = SelectedDot1.y;
			//ClosedShape.visible=false;
			var g1:Graphics=Shape(myCloseShape.getChildByName("line")).graphics;
			var g2:Graphics=Shape(myCloseShape.getChildByName("fill")).graphics;
			g1.clear();
			
			g1.lineStyle(2,cur_color)
			g1.beginFill(cur_color,0);
			g1.drawEllipse(0,0,20,33);
			g1.endFill();
			
			var dot1 = new dot();
			dot1.name = "dot1";
			myCloseShape.addChild(dot1);
			dot1.gotoAndStop(2);
			dot1.Num = 1;
			dot1.x = SelectedDot1.x;
			dot1.y = SelectedDot1.y;
			dot1.buttonMode = true;
			dot1.addEventListener(MouseEvent.MOUSE_DOWN, onDot1Click);
			//dot1.addEventListener(MouseEvent.MOUSE_UP, onDot1Release);
			
			var dot2 = new dot();
			dot2.name = "dot2";
			myCloseShape.addChild(dot2);
			dot2.gotoAndStop(2);
			dot2.Num = 2;
			//trace("  "+SelectedDot1.rowNo+"  "+SelectedDot1.colNo);
			var myEndDot = MovieClip(getChildByName("dot_"+(SelectedDot1.rowNo)+"_"+(SelectedDot1.colNo-1)));
			//trace("  "+myEndDot.rowNo+"  "+myEndDot.colNo);
			dot2.x = myEndDot.x;
			dot2.y = myEndDot.y;
			dot2.buttonMode = true;
			dot2.addEventListener(MouseEvent.MOUSE_DOWN, onDot2Click);
		}
		private function onDot2Click(obj:MouseEvent){
			myDragObj = obj.currentTarget.parent;
			if(myDragObj.ovalReleased == false){
				myDragObj.ovalReleased = true;
				//currDot = obj.currentTarget;
				var myLine = myDragObj.getChildByName("line");
				myDragObj.removeChild(myLine);
				var myFill = myDragObj.getChildByName("fill");
				myDragObj.removeChild(myFill);
			}
			currDot = obj.currentTarget;
			obj.currentTarget.startDrag(false, new Rectangle(50, 20, 620, 420));
			obj.currentTarget.addEventListener(Event.ENTER_FRAME, onDotMove);
			obj.currentTarget.addEventListener(MouseEvent.MOUSE_UP, onDot2Release);
			obj.currentTarget.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onDot2Release);
		}
		private function onDot2Release(obj:MouseEvent){
			currDot.removeEventListener(Event.ENTER_FRAME, onDotMove);
			currDot.removeEventListener(MouseEvent.MOUSE_UP, onDot2Release);
			currDot.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onDot2Release);
			currDot.stopDrag();
			setinPlace();
		}
		private function onDotMove(obj:Event){
			var myRect = obj.currentTarget.parent.getChildByName("myRect");
			if(myRect!=null){
				obj.currentTarget.parent.removeChild(myRect);
			}
			myRect = new MovieClip();
			myRect.name = "myRect";
			var myRectang = new MovieClip();
			myRectang.name = "myRectang";
			var g:Graphics=myRectang.graphics;
			g.lineStyle(2,obj.currentTarget.parent.colr);
			//g.beginFill(XMLData.Panel.@fillColor,1);
			var myDotNum = obj.currentTarget.Num;
			if(myDotNum==1){
				myDotNum = 2;
			}else{
				myDotNum = 1;
			}
			var myOppDot = obj.currentTarget.parent.getChildByName("dot"+myDotNum);
			myRect.x = myOppDot.x;
			myRect.y = myOppDot.y;
			obj.currentTarget.parent.addChild(myRect);
			obj.currentTarget.parent.setChildIndex(myRect, 0);
			//var distance:Number = DistanceTwoPoints(myOppDot.x, mouseX, myOppDot.y, mouseY);
			var distance:Number = DistanceTwoPoints(myOppDot.x, obj.currentTarget.x, myOppDot.y, obj.currentTarget.y);
			g.drawRect(0,-3.4,distance,6.8);
			//var myAng = Math.round(Math.abs(Math.atan2((myOppDot.y-mouseY),(myOppDot.x-mouseX)))*(180/Math.PI));
			var myAng = ((Math.atan2((myOppDot.y-obj.currentTarget.y),(myOppDot.x-obj.currentTarget.x)))*(180/Math.PI));
			if(myAng<0){
				myAng = 180 + myAng;
			}else{
				myAng = 180 + myAng;
			}
			myRectang.rotation = myAng;
			myRect.addChild(myRectang);
			myRect.buttonMode = true;
			myRect.addEventListener(MouseEvent.MOUSE_DOWN, onRectClicked);
			//g.endFill();
		}
		private var myCloseObj;
		private function onRectClicked(obj:MouseEvent){
			myCloseObj = obj.currentTarget.parent;
			myCloseObj.removeChild(obj.currentTarget);
			var myDot1 = myCloseObj.getChildByName("dot1");
			myCloseObj.coOrdArr.push(myDot1.x+"_"+myDot1.y);
			var myDot2 = myCloseObj.getChildByName("dot2");
			myCloseObj.coOrdArr.push(myDot2.x+"_"+myDot2.y);
			var dot3 = new dot();
			dot3.name = "dot3";
			myCloseObj.addChild(dot3);
			dot3.gotoAndStop(2);
			dot3.Num = 3;
			dot3.x = mouseX;
			dot3.y = mouseY;
			myCloseObj.dotNum++;
			myCloseObj.coOrdArr.push(dot3.x+"_"+dot3.y);
			dot3.buttonMode = true;
			dot3.addEventListener(MouseEvent.MOUSE_DOWN, onDotDown);
			dot3.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
			myDot1.removeEventListener(MouseEvent.MOUSE_DOWN, onDot1Click);
			myDot2.removeEventListener(MouseEvent.MOUSE_DOWN, onDot2Click);
			myDot1.addEventListener(MouseEvent.MOUSE_DOWN, onDotDown);
			myDot2.addEventListener(MouseEvent.MOUSE_DOWN, onDotDown);
		}
		private function onDotDown(obj:MouseEvent){
			//trace("GANESH CLICKED")
			currDot = obj.currentTarget;
			myCloseObj = currDot.parent;
			currDot.startDrag(false, new Rectangle(50, 20, 620, 420));
			currDot.addEventListener(MouseEvent.MOUSE_UP, onDotUp);
			currDot.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onDotUp);
			currDot.addEventListener(Event.ENTER_FRAME, onDotEnter);
		}
		private function onDotEnter(evt:Event){
			var lineMc = myCloseObj.getChildByName("lineMc");
			if(lineMc != null){
				myCloseObj.removeChild(lineMc);
			}
			lineMc = new MovieClip();
			lineMc.name = "lineMc";
			myCloseObj.addChild(lineMc);
			myCloseObj.setChildIndex(lineMc,0);
			//trace(currDot.x+" _ "+currDot.y);
			myCloseObj.coOrdArr[currDot.Num-1] = (currDot.x+"_"+currDot.y);
			for(var i=1; i<=myCloseObj.dotNum; i++){
				var myLineMc = new MovieClip();
				myLineMc.name = "line"+i;
				myLineMc.Num = i;
				var g:Graphics=myLineMc.graphics;
				g.lineStyle(2,myCloseObj.colr);
				var movX = Number(myCloseObj.coOrdArr[i-1].split("_")[0]);
				var movY = Number(myCloseObj.coOrdArr[i-1].split("_")[1]);
				g.moveTo(movX, movY);
				var toNum = i;
				if(toNum==myCloseObj.dotNum){
					toNum = 0;
				}
				movX = Number(myCloseObj.coOrdArr[toNum].split("_")[0]);
				movY = Number(myCloseObj.coOrdArr[toNum].split("_")[1]);
				g.lineTo(movX,movY);
				lineMc.addChild(myLineMc);
				myLineMc.buttonMode = true;
				//trace("Gan Number = "+myLineMc.Num);
				myLineMc.addEventListener(MouseEvent.MOUSE_DOWN, onLineDown);
			}
			/*var g:Graphics=lineMc.graphics;
			g.lineStyle(2,myCloseObj.colr);			
			var movX = Number(myCloseObj.coOrdArr[0].split("_")[0]);
			var movY = Number(myCloseObj.coOrdArr[0].split("_")[1]);
			g.moveTo(movX,movY);	
			//trace("movX = "+movX+"  movY = "+movY);
			for(var i=0; i<myCloseObj.coOrdArr.length; i++){
				var toNum = i+1;
				if((toNum) == myCloseObj.coOrdArr.length){
					toNum = 0;
				}
				movX = Number(myCloseObj.coOrdArr[toNum].split("_")[0]);
				movY = Number(myCloseObj.coOrdArr[toNum].split("_")[1]);
				g.lineTo(movX,movY);
				//trace(toNum+" movX = "+movX+"  movY = "+movY);
			}*/
		}
		private function onLineDown(obj:MouseEvent){
			myCloseObj = obj.currentTarget.parent.parent;
			//var myLineNum = obj.currentTarget.Num;
			var myLineNum = Number(obj.currentTarget.name.substr(4));
			//trace(obj.currentTarget.name+"   myLineNum = "+myLineNum+"  ---  "+obj.currentTarget.Num+"  ---  "+obj.currentTarget);
			var lineMc = myCloseObj.getChildByName("lineMc");
			if(lineMc != null){
				myCloseObj.removeChild(lineMc);
			}
			for(var i=1; i<=myCloseObj.dotNum; i++){
				var myDot = myCloseObj.getChildByName("dot"+i);
				myCloseObj.removeChild(myDot);
			}
			var myVal = (mouseX+"_"+mouseY);
			myCloseObj.coOrdArr.splice(myLineNum, 0, myVal);
			myCloseObj.dotNum++;
			var myDotMc;
			for(i=1; i<=myCloseObj.dotNum; i++){
				myDotMc = new dot();
				myDotMc.name = "dot"+i;
				myCloseObj.addChild(myDotMc);
				myDotMc.gotoAndStop(2);
				myDotMc.Num = i;
				myDotMc.x = Number(myCloseObj.coOrdArr[i-1].split("_")[0]);
				myDotMc.y = Number(myCloseObj.coOrdArr[i-1].split("_")[1]);
				myDotMc.buttonMode = true;
				myDotMc.addEventListener(MouseEvent.MOUSE_DOWN, onDotDown);
				//dot3.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
			}
			
			myDotMc = myCloseObj.getChildByName("dot"+(myLineNum+1));
			myDotMc.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
		}
		private function onDotUp(obj:MouseEvent){
			currDot.stopDrag();
			currDot.removeEventListener(MouseEvent.MOUSE_UP, onDotUp);
			currDot.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onDotUp);
			currDot.removeEventListener(Event.ENTER_FRAME, onDotEnter);
			var bj:Object=new Object();
			bj.clips=DotsArray;
			var reObj=getClosestClip(bj);
			var myClosestDot = reObj.clip;
			//var myDot1 = myDragObj.getChildByName("dot1");
			currDot.x = myClosestDot.x;
			currDot.y = myClosestDot.y;
			var lineMc = myCloseObj.getChildByName("lineMc");
			if(lineMc != null){
				myCloseObj.removeChild(lineMc);
			}
			lineMc = new MovieClip();
			lineMc.name = "lineMc";
			myCloseObj.addChild(lineMc);
			myCloseObj.setChildIndex(lineMc,0);
			//trace(currDot.x+" _ "+currDot.y);
			myCloseObj.coOrdArr[currDot.Num-1] = (currDot.x+"_"+currDot.y);
			for(var i=1; i<=myCloseObj.dotNum; i++){
				var myLineMc = new MovieClip();
				myLineMc.name = "line"+i;
				var g:Graphics=myLineMc.graphics;
				g.lineStyle(2,myCloseObj.colr);
				var movX = Number(myCloseObj.coOrdArr[i-1].split("_")[0]);
				var movY = Number(myCloseObj.coOrdArr[i-1].split("_")[1]);
				g.moveTo(movX, movY);
				var toNum = i;
				if(toNum==myCloseObj.dotNum){
					toNum = 0;
				}
				movX = Number(myCloseObj.coOrdArr[toNum].split("_")[0]);
				movY = Number(myCloseObj.coOrdArr[toNum].split("_")[1]);
				g.lineTo(movX,movY);
				lineMc.addChild(myLineMc);
				myLineMc.buttonMode = true;
				myLineMc.addEventListener(MouseEvent.MOUSE_DOWN, onLineDown);
			}
			/*var g:Graphics=lineMc.graphics;
			g.lineStyle(2,myCloseObj.colr);			
			var movX = Number(myCloseObj.coOrdArr[0].split("_")[0]);
			var movY = Number(myCloseObj.coOrdArr[0].split("_")[1]);
			g.moveTo(movX,movY);	
			//trace("movX = "+movX+"  movY = "+movY);
			for(var i=0; i<myCloseObj.coOrdArr.length; i++){
				var toNum = i+1;
				if((toNum) == myCloseObj.coOrdArr.length){
					toNum = 0;
				}
				movX = Number(myCloseObj.coOrdArr[toNum].split("_")[0]);
				movY = Number(myCloseObj.coOrdArr[toNum].split("_")[1]);
				g.lineTo(movX,movY);
				//trace(toNum+" movX = "+movX+"  movY = "+movY);
			}*/
		}
		private function DistanceTwoPoints(x1:Number, x2:Number,  y1:Number, y2:Number): Number {
    		var dx:Number = x1-x2;
    		var dy:Number = y1-y2;
    		return Math.sqrt(dx * dx + dy * dy);
		}
		private var myDragObj;
		private var currDot;
		private function onDot1Click(obj:MouseEvent){
			myDragObj = obj.currentTarget.parent;
			currDot = obj.currentTarget;
			if(myDragObj.ovalReleased == false){
				myDragObj.startDrag();
			}else{
				currDot.startDrag(false, new Rectangle(50, 20, 620, 420));
				currDot.addEventListener(Event.ENTER_FRAME, onDotMove);
			}
			currDot.addEventListener(MouseEvent.MOUSE_UP, onDot1Release);
			currDot.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onDot1Release);
		}
		private function onDot1Release(obj:MouseEvent){
			currDot.removeEventListener(MouseEvent.MOUSE_UP, onDot1Release);
			currDot.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onDot1Release);
			if(myDragObj.ovalReleased == false){
				myDragObj.stopDrag();
				myDragObj.x = 0;
				myDragObj.y = 0;
				var bj:Object=new Object();
				bj.clips=DotsArray;
				var reObj=getClosestClip(bj);
				var myClosestDot = reObj.clip;
				if(myClosestDot.rowNo==Number(XMLData.Dots.@rows)){
					myClosestDot = MovieClip(getChildByName("dot_"+(myClosestDot.rowNo-2)+"_"+(myClosestDot.colNo-1)));
				}
				var myLine = myDragObj.getChildByName("line");
				myLine.x = myClosestDot.x-10;
				myLine.y = myClosestDot.y;
				var myFill = myDragObj.getChildByName("fill");
				myFill.x = myClosestDot.x-10;
				myFill.y = myClosestDot.y;
				var myDot1 = myDragObj.getChildByName("dot1");
				myDot1.x = myClosestDot.x;
				myDot1.y = myClosestDot.y;
				var myDot2 = myDragObj.getChildByName("dot2");
				var myEndDot = MovieClip(getChildByName("dot_"+(myClosestDot.rowNo)+"_"+(myClosestDot.colNo-1)));
				myDot2.x = myEndDot.x;
				myDot2.y = myEndDot.y;
			}else{
				currDot.removeEventListener(Event.ENTER_FRAME, onDotMove);
				currDot.stopDrag();
				setinPlace();
			}
		}
		private function setinPlace(){
			var bj:Object=new Object();
			bj.clips=DotsArray;
			var reObj=getClosestClip(bj);
			var myClosestDot = reObj.clip;
			//var myDot1 = myDragObj.getChildByName("dot1");
			currDot.x = myClosestDot.x;
			currDot.y = myClosestDot.y;
			var myRect = currDot.parent.getChildByName("myRect");
			if(myRect!=null){
				currDot.parent.removeChild(myRect);
			}
			myRect = new MovieClip();
			myRect.name = "myRect";
			var myRectang = new MovieClip();
			myRectang.name = "myRectang";
			var g:Graphics=myRectang.graphics;
			g.lineStyle(2,currDot.parent.colr);
			var myDotNum = currDot.Num;
			if(myDotNum==1){
				myDotNum = 2;
			}else{
				myDotNum = 1;
			}
			var myOppDot = currDot.parent.getChildByName("dot"+myDotNum);
			myRect.x = myOppDot.x;
			myRect.y = myOppDot.y;
			currDot.parent.addChild(myRect);
			currDot.parent.setChildIndex(myRect, 0);
			var distance:Number = DistanceTwoPoints(myOppDot.x, currDot.x, myOppDot.y, currDot.y);
			g.drawRect(0,-3.4,distance,6.8);
			var myAng = ((Math.atan2((myOppDot.y-currDot.y),(myOppDot.x-currDot.x)))*(180/Math.PI));
			if(myAng<0){
				myAng = 180 + myAng;
			}else{
				myAng = 180 + myAng;
			}
			myRectang.rotation = myAng;
			myRect.addChild(myRectang);
			myRect.buttonMode = true;
			myRect.addEventListener(MouseEvent.MOUSE_DOWN, onRectClicked);
		}
		private function AddDots():void
		{
			var cols:Number=Number(XMLData.Dots.@cols);
			var rows:Number=Number(XMLData.Dots.@rows);
			var dist:Number=Number(XMLData.Panel.@width)/(cols+1);
			var dist2:Number=Number(XMLData.Panel.@height)/(rows+1);
			var StartX:Number=Panel.x+dist;
			var StartY:Number=Panel.y+dist2;
			for(var i:int=0;i<rows;i++)
			{
				for(var j:int=0;j<cols;j++)
				{
					var dotmc:MovieClip=new dot();
					addChild(dotmc);
					dotmc.mouseChildren=false;
					dotmc.buttonMode=true;
					dotmc.name="dot_"+i+"_"+j;
					dotmc.gotoAndStop(1);
					dotmc.x=StartX;
					dotmc.rowNo = i+1;
					dotmc.colNo = j+1;
					StartX+=dist;
					dotmc.y=StartY;
					DotsArray.push(dotmc);
					dotmc.addEventListener(MouseEvent.MOUSE_DOWN,SetSelectedMC);
				}
				StartY+=dist2;
				StartX=Panel.x+dist;				
			}
		}
		private function SetSelectedMC(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			
			MouseMoveEnabled=true;
			
			var Line:MovieClip;
			DrawingLine=Line;
			if(cs.currentFrame==3)
			{
				/*ClosedShape.visible=true;
				
				if(ClosedShape.x==0)
				{
					Tar.gotoAndStop(2);
					SelectedDot1=Tar;
					//setChildIndex(ClosedShape,numChildren-1);
					ClosedShape.x=SelectedDot1.x-10;
					ClosedShape.y=SelectedDot1.y;
				}*/
				if(Tar.rowNo==Number(XMLData.Dots.@rows)){
					SelectedDot1 = MovieClip(getChildByName("dot_"+(Tar.rowNo-2)+"_"+(Tar.colNo-1)));
				}else{
					SelectedDot1=Tar;
				}
				AddShape();
			}else
			{
				Tar.gotoAndStop(2);
				SelectedDot1=Tar;
				Panel.addEventListener(MouseEvent.MOUSE_MOVE,onMouseMoveAction);
				stage.addEventListener(MouseEvent.MOUSE_MOVE,onMouseMoveAction);
				stage.addEventListener(MouseEvent.MOUSE_UP,onMouseUpAction);
			}
			
		}
		private function onMouseMoveAction(e:MouseEvent):void
		{
			if(MouseMoveEnabled)
			{
				if(OS.currentFrame==3)
				{
					if(!DrawingLine)
					{
						DrawingLine=new MovieClip();
						addChild(DrawingLine);
					}
					DrawingLine.graphics.clear()
					var g:Graphics=DrawingLine.graphics;
					g.lineStyle(2,cur_color);				
					g.moveTo(SelectedDot1.x,SelectedDot1.y);	
					g.lineTo(mouseX,mouseY);
				}
				if(cs.currentFrame==3)
				{
					//ClosedShape.graphics.clear();
					if(!ClosedShape.getChildByName("dot"))
					{
						var dotmc:MovieClip=new dot();
						dotmc.name="dot";
						ClosedShape.addChild(dotmc);
					}
					
					dotmc=MovieClip(ClosedShape.getChildByName("dot"));
					dotmc.gotoAndStop(2);
					dotmc.x=ClosedShape.mouseX;
					dotmc.y=ClosedShape.mouseY;
					
					
				}
			}
		}
		private function onMouseUpAction(e:MouseEvent):void
		{
			MouseMoveEnabled=false;
			Panel.removeEventListener(MouseEvent.MOUSE_MOVE,onMouseMoveAction);
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,onMouseMoveAction);
			stage.removeEventListener(MouseEvent.MOUSE_UP,onMouseUpAction);
			if(DrawingLine)
			{
				LinesArray.push(DrawingLine);
				var bj:Object=new Object();
				bj.clips=DotsArray;
				var reObj=getClosestClip(bj);
				DrawingLine.graphics.clear();
				DrawingLine.graphics.lineStyle(2,cur_color);	
				DrawingLine.graphics.moveTo(SelectedDot1.x,SelectedDot1.y);	
				DrawingLine.graphics.lineTo(reObj.clip.x,reObj.clip.y);
				reObj.clip.gotoAndStop(2);
				SelectedDot1=reObj.clip;
			}
			
		}
		private function getClosestClip(obj:Object):Object{    
			var closest:Array = [999, null];    
			for (var a:Number = 0; a < obj.clips.length; a++){       
				var res:Number = Math.sqrt(Math.pow(mouseX - obj.clips[a].x, 2) + Math.pow(mouseY - obj.clips[a].y, 2));        
				if (res < closest[0]){            
					closest[0] = res;            
					closest[1] = obj.clips[a];        
				}    
			}    
			return {distance: closest[0], clip:closest[1]}
		}
		private function AddButtons():void
		{
			addChild(OS);
			addChild(cs);
			
			OS.mouseChildren=false;
			OS.buttonMode=true;
			cs.mouseChildren=false;
			cs.buttonMode=true;
			OS.gotoAndStop(3);
			
			OS.x=XMLData.os.@xpos;
			OS.y=XMLData.os.@ypos;
			
			cs.x=XMLData.cs.@xpos;
			cs.y=XMLData.cs.@ypos;
			
			OS.addEventListener(MouseEvent.CLICK,onOpenShape);
			cs.addEventListener(MouseEvent.CLICK,onClosedShape);
			OS.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			OS.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			cs.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			cs.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			
			
			for(var i:int=0;i<XMLData.ColorBtns.Btn.length();i++)
			{
				var cl=getDefinitionByName("b"+(i+1)) as Class;
				var Btn=new cl();
				addChild(Btn);
				
				Btn.buttonMode=true;
				Btn.colorval=XMLData.ColorBtns.Btn[i].@color;
				Btn.gotoAndStop(1);
				ColorBtnsArray.push(Btn);
				Btn.x=XMLData.ColorBtns.Btn[i].@xpos;
				Btn.y=XMLData.ColorBtns.Btn[i].@ypos;
				Btn.addEventListener(MouseEvent.CLICK,changeColorValue);
			}
			ColorBtnsArray[0].gotoAndStop(2);
			cur_color=uint(ColorBtnsArray[0].colorval);
		}
		private function changeColorValue(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			cur_color=Tar.colorval;
			for(var i:int=0;i<ColorBtnsArray.length;i++)
			{
				ColorBtnsArray[i].gotoAndStop(1);
			}
			if(cs.currentFrame==3)
			{
				/*var newColorTransform:ColorTransform = Shape(ClosedShape.getChildByName("fill")).transform.colorTransform;				
				newColorTransform.color = cur_color;
				
				Shape(ClosedShape.getChildByName("fill")).transform.colorTransform = newColorTransform;*/
			}
			Tar.gotoAndStop(2);
		}
		private function onOver(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			if(Tar.currentFrame!=3)
			{
				Tar.gotoAndStop(2);
			}
		}
		private function onOut(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			if(Tar.currentFrame!=3)
			{
				Tar.gotoAndStop(1);
			}
		}
		private function onOpenShape(e:MouseEvent):void
		{
			OS.gotoAndStop(3);
			cs.gotoAndStop(1);
		}
		private function onClosedShape(e:MouseEvent):void
		{
			OS.gotoAndStop(1);
			cs.gotoAndStop(3);
		}
		public function onReset(e:MouseEvent=null):void
		{
			for(var i:int=0;i<LinesArray.length;i++)
			{
				if(LinesArray[i])
				{
					removeChild(LinesArray[i]);
				}
			}
			LinesArray=new Array();
			for(i=0;i<DotsArray.length;i++)
			{
				DotsArray[i].gotoAndStop(1);
			}
			OS.gotoAndStop(3);
			cs.gotoAndStop(1);
			for(i=0;i<ColorBtnsArray.length;i++)
			{				
				ColorBtnsArray[i].gotoAndStop(1);
				if(i==0)
				{
					ColorBtnsArray[i].gotoAndStop(2);
				}
			}
			
			
			MouseMoveEnabled=false;
			if(Panel)
			{
				Panel.removeEventListener(MouseEvent.MOUSE_MOVE,onMouseMoveAction);
			}
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,onMouseMoveAction);
			stage.removeEventListener(MouseEvent.MOUSE_UP,onMouseUpAction);
			cur_color=0x41AD49;
			if(ClosedShape)
			{
				removeChild(ClosedShape);
				AddClosedShape();
			}
			closedShapeNum = 0;
			
		}
		
	}	
}
