﻿package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.URLLoader;	
	import flash.display.Loader;
	import flash.geom.Rectangle;
	import com.yahoo.astra.fl.managers.AlertManager;

	public class Cards {
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var cardsArr:Array;
		private var cardTypeArr:Array;
		private var smallCardsArr:Array;
		private var smallCardLoadCount:Number;
		private var rndCardNum:Number;
		private var rndCardTypeNum:Number;
		
		public function Cards(target:MovieClip):void {
			targetClip = target;
			targetClip.visible = false;
			xmlData = new XML();
			cardTypeArr = ["spade","diamond","flower","heart"];
			cardsArr = new Array();
			smallCardsArr = new Array();
			smallCardLoadCount = 0;
			rndCardNum = -1;
			rndCardTypeNum = -1;
		}
		public function setUp(url:String):void {
			enableBtns(false);
			loadXML(url);
		}		
		private function randomRange(prevRndNum:Number,max:Number, min:Number = 0):Number
		{
			if(max == min) return max;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = prevRndNum;
			if(prevRnd == currRnd){
				currRnd = randomRange(prevRnd,max,min);
			}			
			return currRnd;
		}				
		private function enableBtns(val:Boolean):void{
			targetClip.reset_btn.enabled = val;				
			targetClip.dealBtn.enabled = val;	
			targetClip.selectBtn.enabled = val;
			if(val){
				//targetClip.reset_btn.buttonMode = true;
				targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){reset();});
				
				targetClip.dealBtn.gotoAndStop(1);
				targetClip.dealBtn.buttonMode = true;
				targetClip.dealBtn.useHandCursor = true;
				targetClip.dealBtn.mouseChildren = false;
				targetClip.dealBtn.addEventListener(MouseEvent.CLICK,function(){
					do{
						rndCardNum = randomRange(rndCardNum,1,9);
						rndCardTypeNum = randomRange(rndCardTypeNum,0,cardTypeArr.length-1);
					}while(isCardAvail(cardTypeArr[rndCardTypeNum],rndCardNum));
					
					showCard(cardTypeArr[rndCardTypeNum],rndCardNum);
				});
				targetClip.dealBtn.addEventListener(MouseEvent.MOUSE_OVER,function(){
					targetClip.dealBtn.gotoAndStop(3);
				});
				targetClip.dealBtn.addEventListener(MouseEvent.MOUSE_OUT,function(){
					targetClip.dealBtn.gotoAndStop(1);
				});
				
				targetClip.selectBtn.gotoAndStop(1);
				targetClip.selectBtn.buttonMode = true;
				targetClip.selectBtn.useHandCursor = true;
				targetClip.selectBtn.mouseChildren = false;
				targetClip.selectBtn.addEventListener(MouseEvent.CLICK,function(){
					var smallCardsClip:MovieClip = targetClip.getChildByName("smallCardsClip") as MovieClip;
					smallCardsClip.visible = !smallCardsClip.visible;
				});
				targetClip.selectBtn.addEventListener(MouseEvent.MOUSE_OVER,function(){
					targetClip.selectBtn.gotoAndStop(3);
				});
				targetClip.selectBtn.addEventListener(MouseEvent.MOUSE_OUT,function(){
					targetClip.selectBtn.gotoAndStop(1);
				});
			}
		}
		private function loadXML(path:String) {
			var urlRequest:URLRequest=new URLRequest(path);
			var urlLoader:URLLoader=new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void {
			xmlData = new XML(e.target.data);
			enableBtns(true);
			reset();
			addSmallCards();
			targetClip.visible = true;
		}
		private function reset():void {			
			if(targetClip.getChildByName("bigCardsClip")!=null) targetClip.removeChild(targetClip.getChildByName("bigCardsClip"));
			
			for(var j=0;j<smallCardsArr.length;j++){
				smallCardsArr[j].clickedCount = 0;
			}
			cardsArr = [];
			var bigCardsClip:MovieClip = new MovieClip();
			bigCardsClip.name = "bigCardsClip";
			bigCardsClip.x = Number(xmlData.bigcard.@x);
			bigCardsClip.y = Number(xmlData.bigcard.@y);
			targetClip.addChild(bigCardsClip);
		}
		private function addSmallCards():void{
			var smallCardsClip:MovieClip = new MovieClip();
			smallCardsClip.name = "smallCardsClip";
			var numOfCards:Number = 9;
			for(var i=0;i<numOfCards;i++){
				var smallCard:Card = new Card();
				smallCard.name = "smallCard_"+i;
				smallCardsArr.push({url:cardTypeArr[0]+(i+1),clickedCount:0});
				smallCard.addEventListener(MouseEvent.CLICK,onSmallCardClicked);
				smallCard.gotoAndStop(cardTypeArr[0]+(i+1));
				smallCard.width = Number(xmlData.smallcards.@width);
				smallCard.height = Number(xmlData.smallcards.@height);
				smallCard.x = i * (smallCard.width + Number(xmlData.smallcards.@gap));
				smallCard.y = 0;
				smallCardsClip.addChild(smallCard);				
			}
			smallCardsClip.x = (xmlData.smallcards.@x.toString().length>0) ? Number(xmlData.smallcards.@y) : (targetClip.boundary.width - smallCardsClip.width)/2;
			smallCardsClip.y = Number(xmlData.smallcards.@y);
			targetClip.addChild(smallCardsClip);
			smallCardsClip.visible = false;			
		}
			
		private function onSmallCardClicked(e:MouseEvent):void{
			if(cardsArr.length>=10) return;
			var id:Number = Number(e.target.name.split("_")[1]);
			var clickedCount:Number = smallCardsArr[id].clickedCount;
			if(clickedCount < cardTypeArr.length){
				smallCardsArr[id].clickedCount = clickedCount + 1;
				if(!isCardAvail(cardTypeArr[clickedCount],(id+1))){
					showCard(cardTypeArr[clickedCount],(id+1));
				}else{
					var smallCardsClip:MovieClip = targetClip.getChildByName("smallCardsClip") as MovieClip;
					var smallCard:MovieClip = smallCardsClip.getChildByName("smallCard_"+id) as MovieClip;
					smallCard.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				}				
			}else{
				//trace("All "+((id==0)? "Ace" : (id+1))+"'s have been dealt.");
				AlertManager.createAlert(targetClip, "All "+((id==0)? "Ace" : (id+1))+"s have been dealt.");
			}
		}
		private function isCardAvail(type:String,num:Number):Boolean{
			var isAvail:Boolean = false;
			for(var i=0;i<cardsArr.length;i++){
				if(cardsArr[i].type == type && cardsArr[i].num == num){
					isAvail = true;
					break;
				}
			}
			return isAvail;
		}
		private function showCard(type:String,num:Number):void{
			if(cardsArr.length<10){
				var bigCardsClip:MovieClip = targetClip.getChildByName("bigCardsClip") as MovieClip;
				bigCardsClip.name = "bigCardsClip";
				cardsArr.push({type:type,num:num});
				var id:Number = cardsArr.length-1;
				var col:Number = Number(xmlData.bigcard.@col);
				var gap:Number = Number(xmlData.bigcard.@gap);
				var w:Number = Number(xmlData.bigcard.@width);
				var h:Number = Number(xmlData.bigcard.@height);
				var url:String = cardsArr[id].type + cardsArr[id].num;
				var bigCard:Card = new Card();
				bigCard.name = "bigCard_"+id;
				trace(url)
				bigCard.gotoAndStop(url);
				bigCard.width = Number(xmlData.bigcard.@width);
				bigCard.height = Number(xmlData.bigcard.@height);
				bigCard.x = (id%col) * (w + gap);
				bigCard.y = (Math.floor(id/col) * (h + gap));
				var boundary:Rectangle = new Rectangle(targetClip.boundary.x,targetClip.boundary.y,targetClip.boundary.width - w - 60,targetClip.boundary.height - h - 10);
				bigCard.addEventListener(MouseEvent.MOUSE_DOWN,function(){
					bigCard.startDrag(false,boundary);		 
				});
				bigCard.addEventListener(MouseEvent.MOUSE_UP,function(){
					bigCard.stopDrag();		 
				});
				bigCardsClip.addChild(bigCard);
			}			
		}		
	}
}