﻿package com{
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.display.Loader;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	import flash.net.URLLoader;

	public class ObjectSort extends MovieClip {
		private var MainMc:MovieClip;
		private var XmlData:XML;
		private var totalGroups:Number=0;
		private var groupList:Array = new Array();
		private var currGroup:Number=0;
		private var currGrpList:Array = new Array();
		private var grpRndList:Array = new Array();
		private var totalItem:Number=0;
		private var categoryCount:Number=0;
		private var totalCategory:Number=0;
		private var itemCount:Number=0;
		private var grpItemCount:Number=0;
		private var groupSet:Number=0;
		private var groupHolders:Number=0;
		private var evtTimer:Timer;
		private var currImage;
		private var imgLoader:Loader;

		public function ObjectSort(Mc, tg, gh) {
			MainMc=Mc;
			groupSet=tg;
			groupHolders=gh;
			loadXml("xml/content.xml");
			evtTimer = new Timer(100, 1);
			evtTimer.addEventListener(TimerEvent.TIMER, enabClickEvent)
		}

		private function loadXml(url) {
			var myRequest:URLRequest=new URLRequest(url);
			var myLoader:URLLoader = new URLLoader();
			myLoader.load(myRequest);
			myLoader.addEventListener(Event.COMPLETE, parseXml);
		}

		private function parseXml(evt:Event) {
			
			XmlData=new XML(evt.target.data);
			totalGroups=XmlData.children()[0].children().length();
			for (var i=1; i<=totalGroups; i++) {
				var grpArr=[];
				var grpLength=XmlData.children()[0].children()[i-1].children().length();
				for (var j=1; j<=grpLength; j++) {
					var grpName=XmlData.children()[0].children()[i-1].children()[j-1].attribute("name");
					var itemPathArr=[];
					var itemXPosArr=[];
					var itemYPosArr=[];

					for (var k=1; k<=XmlData.children()[0].children()[i-1].children()[j-1].children().length(); k++) {

						itemXPosArr.push(XmlData.children()[0].children()[i-1].children()[j-1].children()[k-1].attribute("xpos"));
						itemYPosArr.push(XmlData.children()[0].children()[i-1].children()[j-1].children()[k-1].attribute("ypos"));
						itemPathArr.push(XmlData.children()[0].children()[i-1].children()[j-1].children()[k-1]);
					}
					grpArr.push({grpName:grpName, itemPath:itemPathArr, itemXpos:itemXPosArr, itemYpos:itemYPosArr});
				}
				groupList.push(grpArr);

			}
			initActivity();
		}

		private function initActivity() {
			
			var imageContainer:MovieClip = new MovieClip();
			imageContainer.name="imageContainer";
			MainMc.addChild(imageContainer);
			loadNewGroup();
			MainMc.reset_btn.buttonMode = true;
			MainMc.reset_btn.addEventListener(MouseEvent.CLICK, resetFunc);
		}

		private function loadNewGroup() {
			currGroup= (Math.floor(Math.random()*totalGroups)+1);
			currGrpList=[];
			totalItem=0;
			categoryCount=0;
			totalCategory=0;
			itemCount=0;
			grpItemCount=0;
			totalCategory=groupList[currGroup-1].length;
			totalItem=groupList[currGroup-1][categoryCount].itemPath.length;
			removeImgClips();
			
			loadImage();
		}
		
		private function removeImgClips(){
			var imageContainer = MainMc.getChildByName("imageContainer");
			while(imageContainer.numChildren){
				imageContainer.removeChildAt(0);
			}
		}

		private function loadImage() {
			imgLoader=new Loader();
			imgLoader.load(new URLRequest(String(groupList[currGroup-1][categoryCount].itemPath[itemCount])));

			imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, onImageLoad);
		}

		private function onImageLoad(evt:Event) {
			
			itemCount++;
			grpItemCount++;

			var myImage:MovieClip = new MovieClip();
			myImage.addChild(evt.target.content);
			
			myImage.groupNum=(categoryCount+1);
			myImage.dropped=0;
			myImage.name="imgMc"+grpItemCount;
			myImage.visible=false;
			
			var imageContainer=MainMc.getChildByName("imageContainer");
			imageContainer.addChild(myImage);
			currGrpList.push({xpos:groupList[currGroup-1][categoryCount].itemXpos[itemCount-1] , ypos:groupList[currGroup-1][categoryCount].itemYpos[itemCount-1]});
			
			if (itemCount<totalItem) {
				loadImage();
			} else {
				
				categoryCount++;
				if (categoryCount<totalCategory) {
					itemCount=0;
					totalItem=groupList[currGroup-1][categoryCount].itemPath.length;
					loadImage();
				} else {
					totalItem=grpItemCount;
					startActivity();
				}
			}
		}

		private function startActivity() {
			randomize();
			var imageContainer=MainMc.getChildByName("imageContainer");
			for (var i=1; i<=totalItem; i++) {
				var myImage=imageContainer.getChildByName("imgMc"+i);
				myImage.dropNum=0;
				myImage.placeNum=0;
				myImage.x = Number(grpRndList[i-1][0].xpos)-(myImage.width/2);
				myImage.y = Number(grpRndList[i-1][0].ypos)-(myImage.height/2);
				myImage.xpos=myImage.x;
				myImage.ypos=myImage.y;
				myImage.visible=true;
				myImage.buttonMode=true;
				myImage.addEventListener(MouseEvent.MOUSE_DOWN, onDrag);
				myImage.addEventListener(MouseEvent.MOUSE_UP, onDrop);
			}
			for(i=1; i<=groupSet; i++){
				var myGroup = MainMc.getChildByName("groupMc"+i);
				myGroup.groupNum = i;
				myGroup.myTxt.text = groupList[currGroup-1][i-1].grpName;
				for(var j=1; j<=groupHolders; j++){
					var myHolder = myGroup.getChildByName("holderMc"+j);
					myHolder.placed = 0;
				}
			}
		}

		private function onDrag(obj:MouseEvent) {
			currImage=obj.currentTarget;
			currImage.parent.setChildIndex(currImage, (currImage.parent.numChildren-1));
			currImage.startDrag(false, new Rectangle(30, 30, 630, 420));
			//currImage.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onDrop);
		}

		private function onDrop(obj:MouseEvent) {
			/*currImage.stopDrag();
			currImage.removeEventListener(MouseEvent.MOUSE_DOWN, onDrag);
			currImage.removeEventListener(MouseEvent.MOUSE_UP, onDrop);
			currImage.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onDrop);*/
			var dropTar=currImage.dropTarget.parent.parent;
			var setBack=0;
			if (dropTar!=null||dropTar!=Stage) {
				//trace("dropTarNam = "+dropTar.name+" -- "+currImage.dropTarget.parent.name);
				var dropTarPar=currImage.dropTarget.parent;
				if (dropTar.name.substr(0,7)=="groupMc") {
					currImage.stopDrag();
					currImage.removeEventListener(MouseEvent.MOUSE_DOWN, onDrag);
					currImage.removeEventListener(MouseEvent.MOUSE_UP, onDrop);
					//currImage.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onDrop);
					currImage.dropNum = dropTar.groupNum;
					placeImgInGroup(dropTar);
					evtTimer.start();
					checkAllDone();
					
				}else if(dropTar.name=="imageContainer" && dropTarPar.dropNum==0){
					currImage.stopDrag();
					currImage.x=currImage.xpos;
					currImage.y=currImage.ypos;
					//currImage.removeEventListener(MouseEvent.MOUSE_DOWN, onDrag);
					//currImage.removeEventListener(MouseEvent.MOUSE_UP, onDrop);
					currImage=dropTarPar;
					currImage.parent.setChildIndex(currImage, (currImage.parent.numChildren-1));
					currImage.startDrag(false, new Rectangle(30, 30, 630, 420));
				}else {
					//setBack=1;
				}
			} else {
				//setBack=1;
			}
			if (setBack==1) {
				currImage.x=currImage.xpos;
				currImage.y=currImage.ypos;
				currImage.addEventListener(MouseEvent.MOUSE_DOWN, onDrag);
				currImage.addEventListener(MouseEvent.MOUSE_UP, onDrop);
			}
		}
		
		private function enabClickEvent(evt:TimerEvent){
			currImage.addEventListener(MouseEvent.CLICK, resetImagePos);
		}
		
		private function checkAllDone(){
			var allPlaced = 1;
			var allCorrect = 1;
			var imageContainer=MainMc.getChildByName("imageContainer");
			for(var i=1; i<=totalItem; i++){
				var myImage=imageContainer.getChildByName("imgMc"+i);
				if(myImage.dropNum==0){
					allPlaced=0;
					break;
				}else if(myImage.dropNum!=myImage.groupNum){
					allCorrect=0;
				}
			}
			if(allPlaced==1){
				var myFeedBack = MainMc.getChildByName("feedBackMc");
			
				if(allCorrect){
					myFeedBack.gotoAndStop("correct");
				}else{
					myFeedBack.gotoAndStop("wrong");
				}
			}
		}
		
		private function resetFunc(obj:MouseEvent){
			evtTimer.stop();
			evtTimer.reset();
			var myFeedBack = MainMc.getChildByName("feedBackMc");
			myFeedBack.gotoAndStop(1);
			for(var i=1; i<=groupSet; i++){
				var myGroup = MainMc.getChildByName("groupMc"+i);
				myGroup.myTxt.text = "";
			}
			loadNewGroup();
		}
		
		private function resetImagePos(obj:MouseEvent){
			obj.currentTarget.addEventListener(MouseEvent.MOUSE_DOWN, onDrag);
			obj.currentTarget.addEventListener(MouseEvent.MOUSE_UP, onDrop);
			obj.currentTarget.removeEventListener(MouseEvent.CLICK, resetImagePos);
			obj.currentTarget.x = obj.currentTarget.xpos;
			obj.currentTarget.y = obj.currentTarget.ypos;
			var myTar = MainMc.getChildByName("groupMc"+obj.currentTarget.dropNum);
			var myHolder = myTar.getChildByName("holderMc"+obj.currentTarget.placeNum);
			myHolder.placed=0;
			obj.currentTarget.dropNum = 0;
			obj.currentTarget.placeNum = 0;
			var myFeedBack = MainMc.getChildByName("feedBackMc");
			myFeedBack.gotoAndStop(1);
		}
		
		private function placeImgInGroup(myTar){
			for(var i=1; i<=groupHolders; i++){
				var myHolder = myTar.getChildByName("holderMc"+i);
				if(myHolder.placed==0){
					myHolder.placed=1;
					currImage.placeNum=i;
					currImage.x=((myHolder.x+myTar.x)-(currImage.width/2));
					currImage.y=((myHolder.y+myTar.y)-(currImage.height/2));
					break;
				}
			}
		}

		private function randomize() {
			grpRndList=[];
			for (var i=1; i<=totalItem; i++) {
				grpRndList.push(currGrpList.splice(Math.floor(Math.random()*currGrpList.length),1));
			}
		}
	}
}