﻿package com{
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.text.Font;
	import flash.utils.getDefinitionByName;
	
	public class PositionWords {
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var wordArr:Array;
		private var leftAns:Number;
		private var rightAns:Number;
		private var currPage:Number;
		private var isDragging:Boolean;
		private var isImgDragging:Boolean;
		private var type:String;
		private var toBeLoadArr:Array;
		private var loadedCount:Number;
		
		public function PositionWords(target:MovieClip):void {
			targetClip=target;
			targetClip.visible = false;
			xmlData = new XML();
			wordArr = new Array();
			toBeLoadArr = new Array();
			leftAns = -1;
			rightAns = -1;
			currPage = -1;
			loadedCount = 0;
		}
		public function setUp(url:String):void {
			loadXML(url);
		}
		private function randomRange(prevRndNum:Number, max:Number, min:Number = 0):Number
		{
			 if(max == min) return max;
			 var prevRnd:Number = prevRndNum;
			 var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			 if(prevRnd == currRnd){
				currRnd = randomRange(currRnd,max,min);
			 }			
			return currRnd;
		}
		private function rndArr(arr:Array):Array{
			var newArr:Array = []; 
			while (arr.length > 0) {
				newArr.push(arr.splice(Math.round(Math.random() * (arr.length - 1)), 1)[0]);				
			}			
			return newArr;
		}
		private function loadXML(path:String) {
			var urlRequest:URLRequest=new URLRequest(path);
			var urlLoader:URLLoader=new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void {
			xmlData=new XML(e.target.data);			
			reset();			
			targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){reset();});
		}
		public function reset():void{
			targetClip.visible = false;
			targetClip.tapBtn.visible = false;
			currPage = randomRange(currPage,0,xmlData.pages.children().length()-1);
			isDragging = false;
			wordArr = [];
			loadedCount = 0;
			toBeLoadArr = [];
			leftAns = -1;
			rightAns = -1;
			if (targetClip.getChildByName("labelClip")!=null) {
				targetClip.removeChild(targetClip.getChildByName("labelClip"));
			}
			if (targetClip.getChildByName("txt")!=null) {
				targetClip.removeChild(targetClip.getChildByName("txt"));
			}
			if (targetClip.getChildByName("leftPage")!=null) {
				targetClip.removeChild(targetClip.getChildByName("leftPage"));
			}
			if (targetClip.getChildByName("rightPage")!=null) {
				targetClip.removeChild(targetClip.getChildByName("rightPage"));
			}
			if (targetClip.getChildByName("leftAnswer")!=null) {
				targetClip.removeChild(targetClip.getChildByName("leftAnswer"));
			}
			if (targetClip.getChildByName("rightAnswer")!=null) {
				targetClip.removeChild(targetClip.getChildByName("rightAnswer"));
			}
			var noOfWords:Number = xmlData.pages.page[currPage].children().length();
			for(var i=0;i<noOfWords;i++){
				if(targetClip.getChildByName("textClip_"+i)!=null){
					targetClip.removeChild(targetClip.getChildByName("textClip_"+i));
				}				
			}
			if (targetClip.getChildByName("dupClip")!=null) {
				targetClip.removeChild(targetClip.getChildByName("dupClip"));
			}			
			/*if (targetClip.getChildByName("feedback")!=null) {
				targetClip.removeChild(targetClip.getChildByName("feedback"));
			}*/
			var txtArr:Array = new Array();
			for(var j=0;j<noOfWords;j++){
				var newObj:Object = new Object();
				var wordStr:String = xmlData.pages.page[currPage].word[j].text();
				newObj.word = (wordStr=="full") ? ((xmlData.pages.page[currPage].@fullText.toString().length>0) ?  xmlData.pages.page[currPage].@fullText : wordStr) : ((xmlData.pages.page[currPage].@emptyText.toString().length>0) ? xmlData.pages.page[currPage].@emptyText : wordStr);
				newObj.url = xmlData.pages.page[currPage].word[j].@url;				
				newObj.furl = xmlData.pages.page[currPage].word[j].@furl;
				newObj.isCorrect = xmlData.pages.page[currPage].word[j].@isCorrect;
				newObj.font = xmlData.pages.page[currPage].word[j].@font;
				newObj.fontColor = xmlData.pages.page[currPage].word[j].@fontColor;
				newObj.fontSize = xmlData.pages.page[currPage].word[j].@fontSize;
				newObj.x = xmlData.pages.page[currPage].word[j].@x;
				newObj.y = xmlData.pages.page[currPage].word[j].@y;
				newObj.dropped = false;
				txtArr.push(newObj);	
			}
			wordArr[currPage] = rndArr(txtArr);
			
			addPages();
			
			var target:MovieClip;
			for(var k=0;k<wordArr[currPage].length;k++){
				target = (k==0) ? targetClip.getChildByName("leftPage") as MovieClip : targetClip.getChildByName("rightPage") as MovieClip;
				if(wordArr[currPage][k].url.toString().length>0){							
					toBeLoadArr.push({url:wordArr[currPage][k].url,target:target,name:"pageContent"});
				}
				if(wordArr[currPage][k].furl.toString().length>0){
					toBeLoadArr.push({url:wordArr[currPage][k].furl,target:target,name:"pageFill"});
				}
			}			
			loadImage(toBeLoadArr[loadedCount].url,toBeLoadArr[loadedCount].target,toBeLoadArr[loadedCount].name);
		}
		private function checkActType():void{
			type = xmlData.@type.toLowerCase();
			switch(type)
			{
				case "capacityquestion":
					var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
					leftPage.bg.alpha = 0;
					leftPage.border.visible = false;
					var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;
					rightPage.bg.alpha = 0;
					rightPage.border.visible = false;
					addLabel();
					makeClickable();
					//addFeedback();
				break;
				case "capacity":
					targetClip.tapBtn.visible = true;
					targetClip.tapBtn.addEventListener(MouseEvent.CLICK,function(){
						makeTextDraggable();							
						var num:Number = Math.round(Math.random());
						showFills(num);
						targetClip.tapBtn.visible = false;
					});
					addAnswerPage();
					addTxt();
					showTxt();
					//addFeedback();
				break;
				case "mass":
					addAnswerPage();
					addTxt();
					showTxt();
					makeTextDraggable();
					makeImgDraggable()
					//addFeedback();
				break;
				case "match":
					addAnswerPage();
					var leftAnswer:MovieClip = targetClip.getChildByName("leftAnswer") as MovieClip;
					leftAnswer.border.top.visible = false;
					var rightAnswer:MovieClip = targetClip.getChildByName("rightAnswer") as MovieClip;
					rightAnswer.border.top.visible = false;
					addTxt();					
					showTxt();					
					makeTextDraggable();
					//addFeedback();					
				break;
			}			
		}
		
		private function resizePage(page:MovieClip, w:Number, h:Number):void {
			page.bg.x=0;
			page.bg.y=0;
			page.bg.width=w;
			page.bg.height=h;
			//if (page.border.visible) {
				page.border.right.height=h;
				page.border.top.width=w;
				page.border.left.height=h;
				page.border.bottom.width=w;

				page.border.left.x=0;
				page.border.left.y=0;
				page.border.top.x=0;
				page.border.top.y=0;

				page.border.right.x=page.border.top.x+page.border.top.width-page.border.right.width;
				page.border.right.y=0;
				page.border.bottom.x=0;
				page.border.bottom.y=page.border.left.y+page.border.left.height-page.border.bottom.height;
			//}
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
			pageColorTrans.color=fillColor;
			page.bg.transform.colorTransform = pageColorTrans;
			page.bg.alpha = fillAlpha;
			page.bg.visible = (fillAlpha==0) ? false : true;
			page.border.visible = (borderSize>0) ? true : false;
			if (page.border.visible) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				page.border.transform.colorTransform=borderColorTrans;

				page.border.left.width=borderSize;
				page.border.right.width=borderSize;
				page.border.top.height=borderSize;
				page.border.bottom.height=borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		private function addPages():void {
			var leftPage:MovieClip = drawPage(Number(xmlData.bigpage.@width), Number(xmlData.bigpage.@height),  Number(xmlData.bigpage.@bgColor), ((xmlData.bigpage.@bgColor=="")?0:1), Number(xmlData.bigpage.@borderSize), Number(xmlData.bigpage.@borderColor));
			leftPage.name="leftPage";
			leftPage.x = Number(xmlData.bigpage.@x);
			leftPage.y = Number(xmlData.bigpage.@y);
			targetClip.addChild(leftPage);
			
			var rightPage:MovieClip = drawPage(Number(xmlData.bigpage.@width), Number(xmlData.bigpage.@height),  Number(xmlData.bigpage.@bgColor), ((xmlData.bigpage.@bgColor=="")?0:1), Number(xmlData.bigpage.@borderSize), Number(xmlData.bigpage.@borderColor));
			rightPage.name="rightPage";
			rightPage.x = leftPage.x+leftPage.width + 10;
			rightPage.y = leftPage.y;
			targetClip.addChild(rightPage);
			
			targetClip.addEventListener(MouseEvent.MOUSE_UP,onMouseUpcalled);
		}
		private function addAnswerPage():void{
			var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
			var leftAnswer:MovieClip = drawPage(Number(xmlData.answer.@width), Number(xmlData.answer.@height),  Number(xmlData.answer.@bgColor), ((xmlData.answer.@bgColor=="")?0:1), Number(xmlData.answer.@borderSize), Number(xmlData.answer.@borderColor));
			leftAnswer.name = "leftAnswer";
			if(xmlData.answer.@x.toString().length>0){
				leftAnswer.x = Number(xmlData.answer.@x);
			}else{
				leftAnswer.x = leftPage.x + (leftPage.border.width - leftAnswer.width)/2;
			}
			if(xmlData.answer.@y.toString().length>0){
				leftAnswer.y = Number(xmlData.answer.@y);
			}else{
				leftAnswer.y = leftPage.y + leftPage.border.height;
			}
			targetClip.addChild(leftAnswer);			
			
			var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;
			var rightAnswer:MovieClip = drawPage(Number(xmlData.answer.@width), Number(xmlData.answer.@height),  Number(xmlData.answer.@bgColor), ((xmlData.answer.@bgColor=="")?0:1), Number(xmlData.answer.@borderSize), Number(xmlData.answer.@borderColor));
			rightAnswer.name = "rightAnswer";
			if(xmlData.answer.@x.toString().length>0){
				rightAnswer.x = Number(xmlData.answer.@x);
			}else{
				rightAnswer.x = rightPage.x + (rightPage.border.width - rightAnswer.width)/2;
			}
			if(xmlData.answer.@y.toString().length>0){
				rightAnswer.y = Number(xmlData.answer.@y);
			}else{
				rightAnswer.y = rightPage.y + rightPage.border.height;
			}
			targetClip.addChild(rightAnswer);
		}
		private function addTxt():void{			
			var noOfWords:Number = xmlData.pages.page[currPage].children().length();
			for(var i=0;i<noOfWords;i++){
				var textClip:MovieClip = new MovieClip();
				textClip.name = "textClip_"+i;
				var newTxt:TextField = new TextField();
				newTxt.name = "txt";
				newTxt.border = false;
				newTxt.selectable = false;
				newTxt.background = false;
				newTxt.autoSize = TextFieldAutoSize.LEFT;				
				textClip.addChild(newTxt);				
				targetClip.addChild(textClip);							
				textClip.mouseChildren = false;
			}			
		}
 		private function addFeedback():void {
			var feedback:Feedback = new Feedback();
			feedback.name="feedback";
			feedback.x=Number(xmlData.feedback.@x);
			feedback.y=Number(xmlData.feedback.@y);
			feedback.visible=false;
			targetClip.addChild(feedback);
		}
		private function addLabel():void{
			var textClip:MovieClip = new MovieClip();
			textClip.name = "labelClip";
			var newTxt:TextField = new TextField();
			newTxt.name = "txt";
			newTxt.border = false;
			newTxt.selectable = false;
			newTxt.background = false;
			newTxt.autoSize = TextFieldAutoSize.LEFT;
			newTxt.text = xmlData.pages.page[currPage].@label;
			
			var txtFormat:TextFormat = new TextFormat();
			//txtFormat.bold = true;
			var FontC=getDefinitionByName(xmlData.pages.page[currPage].@font) as Class;
			var newFont:Font=new FontC();
			txtFormat.font = newFont.fontName;
			txtFormat.color = uint(xmlData.pages.page[currPage].@fontColor);
			txtFormat.size = Number(xmlData.pages.page[currPage].@fontSize);
			newTxt.setTextFormat(txtFormat);
			newTxt.embedFonts=true;
			
			textClip.addChild(newTxt);				
			targetClip.addChild(textClip);							
			textClip.x = Number(xmlData.pages.page[currPage].@x);
			textClip.y = Number(xmlData.pages.page[currPage].@y);
		}
		private function loadImage(url:String,target:MovieClip,nameStr:String):void {
			// Set properties on my Loader object
			var imageLoader:Loader = new Loader();
			imageLoader.load(new URLRequest(url));
			imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, function(){imageLoaded(imageLoader,target,nameStr);},false,2);
			imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, imageLoadingCompleted,false,1);
		}
		private function imageLoaded(loader:Loader,targ:MovieClip,nameStr:String):void {
			var pageContent:MovieClip = new MovieClip();
			pageContent.name = nameStr;		
			pageContent.addChild(loader);
			targ.addChild(pageContent);
			pageContent.x = (targ.width - pageContent.width)/2;
			pageContent.y = (targ.height - pageContent.height)/2;
			//targ.swapChildren(targ.bg, pageContent);
			//pageContent.mask = targ.bg;
			if(nameStr == "pageFill") pageContent.visible = false;			
		} 
		private function imageLoadingCompleted(e:Event):void{			
			loadedCount++;
			if(loadedCount<toBeLoadArr.length){
				loadImage(toBeLoadArr[loadedCount].url,toBeLoadArr[loadedCount].target,toBeLoadArr[loadedCount].name);
			}else{
				targetClip.visible = true;
				checkActType();
			}
		}
		private function showTxt():void{
			var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
			var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;
			for(var i=0;i<wordArr[currPage].length;i++){
				var textClip:MovieClip = targetClip.getChildByName("textClip_"+i) as MovieClip;				
				var txt:TextField = textClip.getChildByName("txt") as TextField;
				var txtFormat:TextFormat = new TextFormat();
				txtFormat.bold = true;
				txtFormat.font = wordArr[currPage][i].font;
				txtFormat.color = uint(wordArr[currPage][i].fontColor);
				txtFormat.size = Number(wordArr[currPage][i].fontSize);
				txt.text = wordArr[currPage][i].word;	
				txt.setTextFormat(txtFormat);			
				textClip.x =  leftPage.x + (rightPage.x - leftPage.x) - textClip.width/2 - 5;
				textClip.y =  Number(wordArr[currPage][i].y);
				wordArr[currPage][i].x = textClip.x;
				wordArr[currPage][i].y = textClip.y;
			}			
		}		
		private function showFills(num:Number):void{
			if(targetClip.tapBtn.visible){				
				if(num == 0){
					var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
					leftPage.getChildByName("pageFill").visible = true;
					leftPage.getChildByName("pageContent").visible = false;
				}else{
					var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;
					rightPage.getChildByName("pageFill").visible = true;
					rightPage.getChildByName("pageContent").visible = false;
				}
			}
		}
		private function textClipClicked(e:MouseEvent):void{
			if (!isDragging) {
				isDragging = true;
				var boundary:Rectangle=new Rectangle(targetClip.x,targetClip.y,targetClip.width,targetClip.height);
				e.target.startDrag(false,boundary);
			}
		}
		private function onMouseUpcalled(e:MouseEvent):void{
			if(isImgDragging){
				var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
				var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;
				isImgDragging = false;
				leftPage.x = Number(xmlData.bigpage.@x);
				leftPage.y = Number(xmlData.bigpage.@y);
				leftPage.stopDrag();
				rightPage.x = Number(xmlData.bigpage.@x) + leftPage.width + 10;
				rightPage.y = Number(xmlData.bigpage.@y);
				rightPage.stopDrag();
			}
			
			if(!isDragging) return;
			
			var txtClip:MovieClip = targetClip.getChildByName(e.target.name) as MovieClip;
			var index:Number = -1;			
			
			var id:Number = Number(txtClip.name.split("_")[1]);
			
			var leftAnswer:MovieClip = targetClip.getChildByName("leftAnswer") as MovieClip;
			var rightAnswer:MovieClip = targetClip.getChildByName("rightAnswer") as MovieClip;
			
			var rect1:Rectangle = txtClip.getBounds(targetClip);
			var rect2:Rectangle = leftAnswer.getBounds(targetClip);
			var rect3:Rectangle = rightAnswer.getBounds(targetClip);
			
			if (rect1.intersection(rect2).width!=0&&rect1.intersection(rect2).height!=0) {
				if(leftAns > -1){
					var prevTxtClip1:MovieClip = leftAnswer.getChildByName("textClip_"+leftAns) as MovieClip;
					prevTxtClip1.x = Number(wordArr[currPage][leftAns].x);
					prevTxtClip1.y = Number(wordArr[currPage][leftAns].y);
					targetClip.addChild(prevTxtClip1);
					prevTxtClip1.addEventListener(MouseEvent.MOUSE_DOWN,textClipClicked);
				}
				txtClip.stopDrag();
				txtClip.removeEventListener(MouseEvent.MOUSE_DOWN,textClipClicked);
				isDragging = false;
				index = 0;
				txtClip.x = (leftAnswer.width-txtClip.width)/2;
				txtClip.y = (leftAnswer.height-txtClip.height)/2;
				
				leftAnswer.addChild(txtClip);
				leftAns = id;
			}else if(rect1.intersection(rect3).width!=0&&rect1.intersection(rect3).height!=0){
				if(rightAns > -1){
					var prevTxtClip2:MovieClip = rightAnswer.getChildByName("textClip_"+rightAns) as MovieClip;
					prevTxtClip2.x = Number(wordArr[currPage][rightAns].x);
					prevTxtClip2.y = Number(wordArr[currPage][rightAns].y);
					targetClip.addChild(prevTxtClip2);
					prevTxtClip2.addEventListener(MouseEvent.MOUSE_DOWN,textClipClicked);
				}
				txtClip.stopDrag();
				txtClip.removeEventListener(MouseEvent.MOUSE_DOWN,textClipClicked);
				isDragging = false;
				index = 1;
				txtClip.x = (rightAnswer.width-txtClip.width)/2;
				txtClip.y = (rightAnswer.height-txtClip.height)/2;
				
				rightAnswer.addChild(txtClip);
				rightAns = id;
			}
			
			checkAnswer(id,index);
		}
		private function makeClickable():void{
			var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
			leftPage.buttonMode = true;
				leftPage.addEventListener(MouseEvent.CLICK,function(){
				var isCorrect:Boolean = (wordArr[currPage][0].isCorrect == "true") ? true : false;
				leftPage.getChildByName("pageFill").visible = isCorrect;
				rightPage.getChildByName("pageFill").visible = isCorrect;
				leftPage.getChildByName("pageContent").visible = !isCorrect;
				rightPage.getChildByName("pageContent").visible = !isCorrect;
				//showFeedback(isCorrect);
				leftPage.bg.alpha = 1;
				leftPage.border.visible = true;
				rightPage.bg.alpha = 0;					
				rightPage.border.visible = false;
			});
			
			var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;
			rightPage.buttonMode = true;
				rightPage.addEventListener(MouseEvent.CLICK,function(){
				var isCorrect:Boolean = (wordArr[currPage][1].isCorrect == "true") ? true : false;
				leftPage.getChildByName("pageFill").visible = isCorrect;
				rightPage.getChildByName("pageFill").visible = isCorrect;
				leftPage.getChildByName("pageContent").visible = !isCorrect;
				rightPage.getChildByName("pageContent").visible = !isCorrect;
				//showFeedback(isCorrect);
				leftPage.bg.alpha = 0;
				leftPage.border.visible = false;
				rightPage.bg.alpha = 1;					
				rightPage.border.visible = true;
			});
		}		
		private function makeImgDraggable():void{
			var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
			leftPage.addEventListener(MouseEvent.MOUSE_DOWN,function(){
				if (!isImgDragging) {
					isImgDragging = true;
					var boundary:Rectangle=new Rectangle(targetClip.x,targetClip.y,targetClip.width,targetClip.height);
					leftPage.startDrag(false,boundary);
				}
			});
			
			
			var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;
			rightPage.addEventListener(MouseEvent.MOUSE_DOWN,function(){
				if (!isImgDragging) {
					isImgDragging = true;
					var boundary:Rectangle=new Rectangle(targetClip.x,targetClip.y,targetClip.width,targetClip.height);
					rightPage.startDrag(false,boundary);
				}
			});
			
		}
		private function makeTextDraggable():void{
			for(var i=0;i<wordArr[currPage].length;i++){
				var textClip:MovieClip = targetClip.getChildByName("textClip_"+i) as MovieClip;
				textClip.addEventListener(MouseEvent.MOUSE_DOWN,textClipClicked);
			}
		}
		private function checkAnswer(id:Number,index:Number):void{
			var correctCount:Number = 0;
			var droppedCount:Number = 0;
			
			if(index != -1){
			wordArr[currPage][index].dropped = true;						
				for(var i=0;i<wordArr[currPage].length;i++){
					if(!wordArr[currPage][i].dropped){
						break;
					}else{
						
						if(type != "capacity"){
							if(wordArr[currPage][id].word == wordArr[currPage][index].word){
								correctCount++;
							}
						}else{
							var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
							var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;							
							if(leftAns!=-1 && leftPage.getChildByName("pageFill").visible && wordArr[currPage][leftAns].word.toLowerCase() == "full"){
								correctCount++;
							}
							if(rightAns!=-1 && rightPage.getChildByName("pageFill").visible && wordArr[currPage][rightAns].word.toLowerCase() == "full"){
								correctCount++;
							}							
						}
						droppedCount++;						
					}
				}
				if(wordArr[currPage].length == droppedCount){
					if(droppedCount == correctCount){
						//showFeedback(true);
					}else{
						//showFeedback(false);
					}
				}
			}
		}
		private function showFeedback(isCorrect:Boolean):void {
			var feedback:MovieClip=targetClip.getChildByName("feedback") as MovieClip;
			if (isCorrect) {
				feedback.gotoAndStop(2);
			} else {
				feedback.gotoAndStop(1);
			}
			feedback.visible=true;
		}
	}	
}